# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xvhd`](#dsc_xvhd): The DSC xVHD resource type. Automatically generated from version 3.4.0.0
* [`dsc_xvhdfile`](#dsc_xvhdfile): The DSC xVhdFile resource type. Automatically generated from version 3.4.0.0
* [`dsc_xvmhyperv`](#dsc_xvmhyperv): The DSC xVMHyperV resource type. Automatically generated from version 3.4.0.0
* [`dsc_xvmswitch`](#dsc_xvmswitch): The DSC xVMSwitch resource type. Automatically generated from version 3.4.0.0

## Resource types

### `dsc_xvhd`

The DSC xVHD resource type.
Automatically generated from version 3.4.0.0

#### Properties

The following properties are available in the `dsc_xvhd` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should the VHD be created or deleted

##### `dsc_filesizebytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Current size of the VHD

##### `dsc_generation`

Data type: `Optional[Enum['Vhd', 'Vhdx']]`

Virtual disk format - Vhd or Vhdx

##### `dsc_id`

Data type: `Optional[String]`

Virtual Disk Identifier

##### `dsc_isattached`

Data type: `Optional[Boolean]`

Is the VHD attached to a VM or not

##### `dsc_maximumsizebytes`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Maximum size of Vhd to be created

##### `dsc_parentpath`

Data type: `Optional[String]`

Parent VHD file path, for differencing disk

##### `dsc_type`

Data type: `Optional[String]`

Type of Vhd - Dynamic, Fixed, Differencing

#### Parameters

The following parameters are available in the `dsc_xvhd` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the VHD File

##### `dsc_path`

namevar

Data type: `String`

Folder where the VHD will be created

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvhdfile`

The DSC xVhdFile resource type.
Automatically generated from version 3.4.0.0

#### Properties

The following properties are available in the `dsc_xvhdfile` type.

##### `dsc_checksum`

Data type: `Optional[Enum['ModifiedDate', 'SHA-1', 'SHA-256', 'SHA-512']]`

 

##### `dsc_filedirectory`

Data type: `Array[Struct[{
              type => Optional[Enum['File', 'Directory']],
              ensure => Optional[Enum['Present', 'Absent']],
              content => Optional[String],
              destinationpath => String,
              force => Optional[Boolean],
              sourcepath => Optional[String],
              attributes => Optional[Array[Enum['ReadOnly', 'Hidden', 'System', 'Archive']]],
              recurse => Optional[Boolean]
            }]]`

The FileDirectory objects to copy to the VHD

#### Parameters

The following parameters are available in the `dsc_xvhdfile` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vhdpath`

namevar

Data type: `String`

Path to the VHD

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmhyperv`

The DSC xVMHyperV resource type.
Automatically generated from version 3.4.0.0

#### Properties

The following properties are available in the `dsc_xvmhyperv` type.

##### `dsc_cpuusage`

Data type: `Optional[Integer[0, 4294967295]]`

CPU Usage of the VM

##### `dsc_creationtime`

Data type: `Optional[Timestamp]`

Creation time of the VM

##### `dsc_enableguestservice`

Data type: `Optional[Boolean]`

Enable Guest Service Interface for the VM.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should the VM be created or deleted

##### `dsc_generation`

Data type: `Optional[Integer[0, 4294967295]]`

Virtual machine generation

##### `dsc_hasdynamicmemory`

Data type: `Optional[Boolean]`

Does VM has dynamic memory enabled

##### `dsc_id`

Data type: `Optional[String]`

VM unique ID

##### `dsc_macaddress`

Data type: `Optional[Array[String]]`

MAC address(es) of the VM NICs.

##### `dsc_maximummemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Maximum RAM for the VM. This enable dynamic memory.

##### `dsc_memoryassigned`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Memory assigned to the VM

##### `dsc_minimummemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Minimum RAM for the VM. This enables dynamic memory.

##### `dsc_networkadapters`

Data type: `Optional[Array[String]]`

Network adapters' IP addresses of the VM

##### `dsc_notes`

Data type: `Optional[String]`

Notes about the VM.

##### `dsc_path`

Data type: `Optional[String]`

Folder where the VM data will be stored

##### `dsc_processorcount`

Data type: `Optional[Integer[0, 4294967295]]`

Processor count for the VM

##### `dsc_restartifneeded`

Data type: `Optional[Boolean]`

If specified, shutdowns and restarts the VM as needed for property changes

##### `dsc_secureboot`

Data type: `Optional[Boolean]`

Enable secure boot for Generation 2 VMs.

##### `dsc_startupmemory`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Startup RAM for the VM.

##### `dsc_state`

Data type: `Optional[Enum['Running', 'Paused', 'Off']]`

State of the VM.

##### `dsc_status`

Data type: `Optional[String]`

Status of the VM

##### `dsc_switchname`

Data type: `Optional[Array[String]]`

Virtual switch(es) associated with the VM

##### `dsc_uptime`

Data type: `Optional[String]`

Uptime of the VM

##### `dsc_vhdpath`

Data type: `String`

VHD associated with the VM

##### `dsc_waitforip`

Data type: `Optional[Boolean]`

Waits for VM to get valid IP address.

#### Parameters

The following parameters are available in the `dsc_xvmhyperv` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the VM

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xvmswitch`

The DSC xVMSwitch resource type.
Automatically generated from version 3.4.0.0

#### Properties

The following properties are available in the `dsc_xvmswitch` type.

##### `dsc_allowmanagementos`

Data type: `Optional[Boolean]`

Specify if the VM host has access to the physical NIC

##### `dsc_bandwidthreservationmode`

Data type: `Optional[Enum['Default', 'Weight', 'Absolute', 'None', 'NA']]`

Type of Bandwidth Reservation Mode to use for the switch

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Whether switch should be present or absent

##### `dsc_id`

Data type: `Optional[String]`

Unique ID for the switch

##### `dsc_netadapterinterfacedescription`

Data type: `Optional[String]`

Description of the network interface

##### `dsc_netadaptername`

Data type: `Optional[String]`

Network adapter name for external switch type

#### Parameters

The following parameters are available in the `dsc_xvmswitch` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the VM Switch

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_type`

namevar

Data type: `Enum['External', 'Internal', 'Private']`

Type of switch

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

